<HTML>
<HEAD>

<!-- Please preserve look and feel! -->

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<TITLE>Sample descData meta macros</TITLE>

<META name="description" content="Description of the DescData User Commands">

<META name="keywords" content="macros, commands, user">

</HEAD>

<BODY BGCOLOR="#DDDDDD" TEXT="#000000">
<a name="top">
<table>
<td width=100%><td>
<IMG SRC="/doc/gifs/LIGO.gif" ALIGN=right ALT="LIGO.gif">
</table>

<h3> The <i>descData</i> User Commands (Meta Macros) </h3>
<b>All user commands have the form:</b>
<p>
<tt><font color="red">
<b>ldasJob</b> { -name {} -password {} -email {} } { <b>userCmd</b> -opt1 {} ... }
</tt></font>
<p>
Which is in the format of a <a href=http://www.tcl.tk/software/tcltk/><b>Tcl</b></a> command, <b>ldasJob</b>, with two required
arguments:
<ol>
<li>
A Tcl list of <b>user information</b> consisting of username,
password, and e-mail address.  All fields must be filled or
the command will be rejected.
<li>
A <b>user command</b> in the form of a Tcl list, for which there
exists a "meta" macro file which can be expanded into Tcl code
which can then be evaluated by the LDAS system.
<br>
An argument <b>must be provided to every option field</b> for
any given command or the command will be rejected.<br>
Some option fields will accept a "null" argument consisting of
a matching pair of braces <b>"{}"</b> with no interposed space.
<br>
Meta macros consist of a prototype declaration of the arguments
for the given user command, and a template describing the calling
order of API specific blocks of Tcl code which are concatenated
into a larger block comprising the complete request, which can
then be distributed by the assistant manager for interpretation
by the low level API's.
<br>
These API specific blocks are maintained as API specific macro
files consisting of immediately interpretable Tcl code.
</ol>
The only descData command we have now is used to retrieve database schema 
information via the metadata API:
<ul>
<a href="#descmetadata"><li><b><i>descMetaData</i></b></a>
</ul>
<!-- bottom of page pointer section --> 
<center>
<h2>
<a href="#descMetadata">descMetaData</a>
<IMG SRC="/doc/gifs/arrow_right.gif" ALT="arrow_right.gif">
</h2>
</center>
<!-- Here we put the stuff which will become the linked pages --> 
<hr>
<ul>
<li>
<a name="descmetadata">
<b><i>descMetaData</i></b>
<p>
Returns information on database schema such as names of table columns,
keys, column data types. 
<p>
Calling convention (all on a single line):
<p>
<b>ldasJob</b> &nbsp;
<b>{</b>
-name &nbsp; <i>"username"</i> &nbsp;
-password &nbsp; <i>"********"</i> &nbsp; 
-email &nbsp; <i>"user@foobar.edu"</i><b>}</b> &nbsp; 
<b>{<i>descMetaData</i></b> &nbsp; 
<a href=#returnprotocol>-returnprotocol</a>  &nbsp;
   <font color="red"> <i>URL</i></font> &nbsp; 
<a href=#returnformat>-returnformat</a>    &nbsp;
   <font color="red"> <i>ilwd LIGO_LW</i></font> &nbsp; 
<a href=#table>-table</a>           &nbsp;
   <font color="red"> <i>{ <i>Tcl list }</i></i></font> &nbsp; 
<a href=#column>-column</a>          &nbsp;
   <font color="red"> <i>{ <i>Tcl list }</i></i></font> &nbsp; 
<a href=#type>-type</a>            &nbsp;
   <font color="red"> <i>{ <i>Tcl list }</i></i></font> &nbsp; 
<a href=#key>-key</a>             &nbsp;
   <font color="red"> <i>{ <i>Tcl list }</i></i></font> &nbsp;
<a href=#database>-database</a>		 &nbsp;
   <font color="red"> <i>dsname</i></font> &nbsp;
<b>}</b>
<p>
<font color="green">Option Descriptions:</font>
<ul>
<p>
<a name=returnprotocol>
<b>-returnprotocol:</b> &nbsp; &nbsp; 
                   <tt>
                   http ftp file port
                   </tt>
<p>
<ul>
<tt>
The returnprotocol specifies the destination that
the result of the command should be delivered to.
The argument to the <b>-returnprotocol</b> option conforms
to the usual browser conventions for URL's for determining
the location of the results of the user request.<br>
The <b>http</b>, <b>ftp</b>, and <b>file</b> options
cause a URL pointer to the location of the results to be
returned by e-mail.<br>
The possible formats of the argument are:
<p>
<li>http://host:port/dir/...<p> 
<li>ftp://host:port/dir/...<p>
<li>file:/path/... (note, only one "/")<p>
<p><font color="red">
NOTE: Embedded spaces in the argument to the -returnprotocol
option will cause the request to fail.</font>
</tt>
</ul>
<p>
<a name=returnformat>
<b>-returnformat:</b> &nbsp; &nbsp; <tt>ilwd LIGO_LW</tt>
<p>
<ul>
<tt>
The argument of the -returnformat option is the
name of the data type to use in formatting the result
of the user request.<br>
The possible output formats currently supported by the system 
are <b>ilwd text</b>,
and <b>LIGO_LW</b> (an XML format).
</tt>
</ul>
<p>
<a name="tableoption">
<p>
<a name=table>
<b>-table:</b> &nbsp; &nbsp; <tt>all <i>tabname</i></tt>
<p>
<ul>
<tt>
The argument of the <b>-table</b> option can be one of:
<li>all - for all tables
<li><i>tabname</i> for a single table e.g. frameset
<p>
The table option returns the column names of the specified table or
of all tables; this option is overrided by either the 
<a href="#keyoption"><i>-key</i> option</a> or
<a href="#typeoption"><i>-type</i> option</a> 
if their option argument is not <i>none</i>. 
</tt>
</ul>
<a name="columnoption">
<p>
<a name=column>
<b>-column:</b> &nbsp; &nbsp; <tt>all none <i>colname</i></tt>
<p>
<tt>
The argument of the <b>-column</b> option can be one of:
<li>all - for all columns
<li>none - no columns (used with <i>-key</i> or <i>-type</i> option)
<li><i>colname</i> for a single column e.g. frameset
<p>
The column option is used when requesting the data attributes of 
columns in tables; all returns data attributes of all columns
of table specified in -table option; if a column name
is specified, the data attributes for that column is returned.
This option must be none when using the 
<a href="#keyoption"><i>-key</i> option</a> or
<a href="#typeoption"><i>-type</i> option</a> 
</tt>
<a name="typeoption">
<p>
<a name=type>
<b>-type:</b> &nbsp; &nbsp; <tt>all none</i></tt>
<p>
<ul>
<tt>
The argument of the <b>-type</b> option can be one of:
<li>none - option is not used
<li>all  - all data attributes
<p>
The type option returns the data attributes of column or
all columns as specified in the 
<a href="#columnoption"><i>-column</i> option</a>
belonging to the table specified in the  
<a href="#tableoption"><i>-table</i> option.</a>
</tt>
</ul>
<a name="keyoption">
<p>
<a name=key>
<b>-key:</b> &nbsp; &nbsp; <tt>none primary foreign</tt>
<p>
<ul>
<tt>
The argument of the <b>-key</b> option can be one of:
<li>none - key option is not used
<li>primary - get primary keys for table
<li>foreign - get foreign keys for table
<p>
The key option returns the  primary or foreign key for
table specified in
<a href="#tableoption"><i>-table</i> option.</a>
The <a href="#columnoption"><i>-column</i> option</a>
must be set to none since it is not used with this option.
If none is specified, the <i>-key</i> option is not
used.
</tt>
</ul>
<p>
<a name=database>
<b>-database:</b> &nbsp; &nbsp; <tt>dsname</tt>
<p>
</ul>
<ul>
<p>
<tt>
The argument of -database option is a valid database dataset name for
the site that the command applies e.g. <i>cit_1</i> and <i>cit_test</i> are
dataset names for site <i>ldas-dev</i>, <i>lho_1</i> and <i>lho_test</i> are
dataset names for site <i>ldas-wa</i> etc. For dsnames of sites,
please visit the LDAS database link on each ldas site web page.
If this option is not specified, insertion is done from the default database.
</tt>
</ul>
</ul>
<p><font color="blue">Examples of descMetaData command:</font>
<p>
<li>
for LDAS registered user <i>foo</i> to request column names from 
all database tables in ilwd format and have the results delivered 
via user <i>foo</i>'s email, submit:</p>
<b>ldasJob</b> &nbsp;
<b>{</b>
-name &nbsp; <i>"foo"</i> &nbsp;
-password &nbsp; <i>"********"</i> &nbsp; 
-email &nbsp; <i>"foo@foobar.edu"</i><b>}</b> &nbsp; 
<b>{<i>descMetaData</i></b> &nbsp; 
-returnprotocol  &nbsp; <font color="red"> <i>"foo@foobar.edu"</i></font> &nbsp; 
-returnformat    &nbsp; <font color="red"> <i>ilwd</i></font> &nbsp; 
-table           &nbsp; <font color="red"> <i>all</i></font> &nbsp; 
-column          &nbsp; <font color="red"> <i>none</i></font> &nbsp;
-type            &nbsp; <font color="red"> <i>none</i></font> &nbsp;
-key             &nbsp; <font color="red"> <i>none</i></font> &nbsp;
<b>}</b>
<p>
<a href="descMetaData1.ilwd">Result in ilwd</a>
<p>
<li>
for LDAS registered user <i>foo</i> to request data attributes from 
ringdown table, have the results output in Ligo LW format and 
delivered to user <i>foo</i>'s email, submit:</p>
<b>ldasJob</b> &nbsp;
<b>{</b>
-name &nbsp; <i>"foo"</i> &nbsp;
-password &nbsp; <i>"********"</i> &nbsp; 
-email &nbsp; <i>"foo@foobar.edu"</i><b>}</b> &nbsp; 
<b>{<i>descMetaData</i></b> &nbsp; 
-returnprotocol  &nbsp; <font color="red"> <i>"foo@foobar.edu"</i></font> &nbsp;
-returnformat    &nbsp; <font color="red"> <i>LIGO_LW</i></font> &nbsp; 
-table           &nbsp; <font color="red"> <i>ringdown</i></font> &nbsp; 
-column          &nbsp; <font color="red"> <i>none</i></font> &nbsp;
-type            &nbsp; <font color="red"> <i>all</i></font> &nbsp;
-key             &nbsp; <font color="red"> <i>none</i></font> &nbsp;
<b>}</b>
<p>
<a href="descMetaData2.xml">Result in LIGO_LW</a>
<p>
<li>
for LDAS registered user <i>foo</i> to request primary keys from 
statistics tables in ilwd format and have the results delivered via user <i>foo</i>'s email, submit:</p>
<b>ldasJob</b> &nbsp;
<b>{</b>
-name &nbsp; <i>"foo"</i> &nbsp;
-password &nbsp; <i>"********"</i> &nbsp; 
-email &nbsp; <i>"foo@foobar.edu"</i><b>}</b> &nbsp; 
<b>{<i>descMetaData</i></b> &nbsp; 
-returnprotocol  &nbsp; <font color="red"> <i>"foo@foobar.edu"</i></font> &nbsp;
-returnformat    &nbsp; <font color="red"> <i>ilwd</i></font> &nbsp;
-table           &nbsp; <font color="red"> <i>statistics</i></font> &nbsp; 
-column          &nbsp; <font color="red"> <i>none</i></font> &nbsp;
-type            &nbsp; <font color="red"> <i>none</i></font> &nbsp;
-key             &nbsp; <font color="red"> <i>primary</i></font> &nbsp;
<b>}</b>
<p>
<a href="descMetaData3.ilwd">Result in ilwd</a>
<p>
<li>
for LDAS registered user <i>foo</i> to request primary keys from 
statistics tables in ilwd format from database <i>cit_1</i> instead of
default database and have the results delivered via user <i>foo</i>'s email, submit:</p>
<b>ldasJob</b> &nbsp;
<b>{</b>
-name &nbsp; <i>"foo"</i> &nbsp;
-password &nbsp; <i>"********"</i> &nbsp; 
-email &nbsp; <i>"foo@foobar.edu"</i><b>}</b> &nbsp; 
<b>{<i>descMetaData</i></b> &nbsp; 
-returnprotocol  &nbsp; <font color="red"> <i>"foo@foobar.edu"</i></font> &nbsp;
-returnformat    &nbsp; <font color="red"> <i>ilwd</i></font> &nbsp;
-table           &nbsp; <font color="red"> <i>statistics</i></font> &nbsp; 
-column          &nbsp; <font color="red"> <i>none</i></font> &nbsp;
-type            &nbsp; <font color="red"> <i>none</i></font> &nbsp;
-key             &nbsp; <font color="red"> <i>primary</i></font> &nbsp;
-database        &nbsp; <font color="red"> <i>cit_1</i></font> &nbsp;
<b>}</b>
<p>
</ul></ul>
<p>
Note that there is a maximum row limit (configurable in resource file) imposed on 
retrieving the results so if the result set exceeds this limit, the set is truncated in the output.
There will be an indication in the email reply to the user if the full set of results gets truncated.
<!-- bottom of page pointer section -->  
<center>
<h2>
<IMG SRC="/doc/gifs/arrow_up.gif" ALT="arrow_up.gif">
<a href="#top">Back to Top</a>
<IMG SRC="/doc/gifs/arrow_up.gif" ALT="arrow_up.gif">
</h2>
</center>
<!-- End of descMetaData --> 

</ul>
</BODY>

<!-- VI POWERED! -->

</HTML>
